#include <Windows.h>
#include <Mstcpip.h>
#include <winsock2.h>
#include <ws2tcpip.h>
#include <stdio.h>
#include <tchar.h>

#include <RCF/RCF.hpp>

// Need to link with Ws2_32.lib
#pragma comment(lib, "ws2_32.lib")

RCF_BEGIN(Interface_Rcf, "Interface_Rcf")
   RCF_METHOD_V1(void, echo, const std::string&)
RCF_END(Interface_Rcf)

class InterfaceImpl
   {
   public:
      void echo (const std::string& str)
         {
         printf("From client: %s\n", str.c_str());
         }
   };


int main(int argc, char* argv[])
{
   RCF::RcfInitDeinit rcfInit;

   InterfaceImpl impl;
   RCF::RcfServer server( RCF::TcpEndpoint("192.168.2.232",50001) );
   server.bind<Interface_Rcf>(impl);
   server.start();
   
   std::cout << "Press Enter to exit..." << std::endl;
   std::cin.get();
   return 0;
}